#include <bits/stdc++.h>

using namespace std;

const int N = 5000 + 7;

int a[N][N];
int ind[N][N];

set <pair <int, int> > q;
const int M = 1e6;
bool u[M];
vector <int> g[M];
int _x[M], _y[M];

void dfs(int v)
{
	cout << _x[v] << ' ' << _y[v] << '\n';
	u[v] = true;
	for (int to : g[v])
	{
		if (!u[to])
		{
			dfs(to);
			break;
		}
	}
}

void add_edge(int u, int v)
{
	q.insert({u, v});
	q.insert({v, u});
}

void del_edge(int u, int v)
{
	q.erase({u, v});
	q.erase({v, u});
}

int main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		_x[4 * i] = _x[4 * i + 1] = 2 * x;
		_x[4 * i + 2] = _x[4 * i + 3] = 2 * x + 1;
		_y[4 * i + 1] = _y[4 * i + 3] = 2 * y + 1;
		_y[4 * i] = _y[4 * i + 2] = 2 * y;
		ind[2 * x][2 * y] = 4 * i;
		ind[2 * x][2 * y + 1] = 4 * i + 1;
		ind[2 * x + 1][2 * y] = 4 * i + 2;
		ind[2 * x + 1][2 * y + 1] = 4 * i + 3;
		add_edge(4 * i, 4 * i + 1);
		add_edge(4 * i + 1, 4 * i + 3);
		add_edge(4 * i + 3, 4 *  i + 2);
		add_edge(4 * i, 4 * i + 2);
		a[x][y] = 1;
	}
	for (int x = 0; x < N; x++)
	{
		for (int y = 0; y + 1 < N; y++)
		{
			if (a[x][y] && a[x][y + 1])
			{
				del_edge(ind[2 * x][2 * y + 1], ind[2 * x + 1][2 * y + 1]);
				del_edge(ind[2 * x][2 * (y + 1)], ind[2 * x + 1][2 * (y + 1)]);
				add_edge(ind[2 * x][2 * y + 1], ind[2 * x][2 * (y + 1)]);
				add_edge(ind[2 * x + 1][2 * y + 1], ind[2 * x + 1][2 * (y + 1)]);
			}
		}
	}
	for (int x = 0; x + 1 < N; x++)
	{
		for (int y = 0; y < N; y++)
		{
			if (a[x][y] && a[x + 1][y])
			{
				del_edge(ind[2 * x + 1][2 * y], ind[2 * x + 1][2 * y + 1]);
				del_edge(ind[2 * (x + 1)][2 * y], ind[2 * (x + 1)][2 * y + 1]);
				add_edge(ind[2 * x + 1][2 * y], ind[2 * (x + 1)][2 * y]);
				add_edge(ind[2 * x + 1][2 * y + 1], ind[2 * (x + 1)][2 * y + 1]);
			}
		}
	}
	for (auto c : q) g[c.first].push_back(c.second);
	dfs(0);
}
