#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2007;
long long dp[MAX_N][MAX_N];
const long long INF = 1e18;
long long t[MAX_N + 1], p[MAX_N + 1];

long long rec(int n1, int t1) {
    if(n1 == 0) return INF;
    long long minn = INF;
    for (int j = 1; j <= n1; j++) {
        for (int i = t1; i > max(t1 - t[n1], -1LL); i--) {
            if(dp[j][i] == INF) continue;
            minn = min(dp[j][i], minn);
        }
    }
    minn = min(minn, rec(n1 - 1, t1 - t[n1]) + p[n1]);
    //cout << n1 << " " << t1 << " " << minn << endl;
    return minn;
}

int main() {
    int n, tt;
    cin >> n >> tt;
    pair <long long, long long> tp[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> tp[i].first >> tp[i].second;
    }
    sort(tp + 1, tp + n + 1, greater <pair <long long, long long>>());
    dp[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        t[i] = tp[i].first;
        p[i] = tp[i].second;
    }
    for (int i = 1; i <= tt; i++) dp[0][i] = INF;
    for (int i = 1; i <= n; i++) {
        dp[i][0] = 0;
        for (int j = 1; j <= tt; j++) {
            dp[i][j] = dp[i - 1][j];
            if (j - t[i] >= 0 && dp[i - 1][j - t[i]] + p[i] < dp[i][j]) dp[i][j] = dp[i - 1][j - t[i]] + p[i];
        }
    }
    long long ans = INF;
    long long minn = INF;
    for (long long i = tt; i >= 1; i--) {
        if (dp[n][i] != INF) {
            int cur_t = i;
            long long last;
            for (int j = n; j >= 0; j--) {
                if (dp[j][cur_t] == dp[j - 1][cur_t - t[j]] + p[j]) {
                    if (j == 1) {
                        last = INF;
                        break;
                    }
                    cur_t -= t[j];
                    continue;
                }
                last = t[j];
                break;
            }
            //cout << i << ' ' << last << endl;
            if (i + last > tt) minn = min(minn, dp[n][i]);
        }
    }
    //cout << "!!!" << dp[2][7] << ' ' << dp[1][0] << endl;
    for (int j = 1; j <= n; j++) {
        for (int i = tt; i > max(tt - t[n], -1LL); i--) {
            if(dp[j][i] == INF) continue;
            minn = min(dp[j][i], minn);
        }
    }

    cout << rec(n, tt) << endl;
    return 0;
}
