import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;

public class Task {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String[] enter = reader.readLine().split(" ");
        double n, m, h, w;
        n = Long.parseLong(enter[0]);
        m = Long.parseLong(enter[1]);
        h = Long.parseLong(enter[2]);
        w = Long.parseLong(enter[3]);

        int resV1 = 0;
        int resV2 = 0;
        // Both should do:
        while (true) {
            boolean exit = true;
            if (n > h && n > w) {
                resV1++;
                resV2++;
                n /= 2;
                exit = false;
            }
            if (m > h && m > w) {
                m /= 2;
                resV1++;
                resV2++;
                exit = false;
            }
            if (exit) {
                break;
            }
        }

        // Variant 1
        // n to h; m to w
        while (true) {
            boolean exit = true;
            if (n > h) {
                resV1++;
                n /= 2;
                exit = false;
            }
            if (m > w) {
                m /= 2;
                resV1++;
                exit = false;
            }
            if (exit) {
                break;
            }
        }

        // Variant 2
        // n to w; m to h
        while (true) {
            boolean exit = true;
            if (n > w) {
                resV2++;
                n /= 2;
                exit = false;
            }
            if (m > h) {
                m /= 2;
                resV2++;
                exit = false;
            }
            if (exit) {
                break;
            }
        }
        System.out.println(Math.min(resV1, resV2));
    }

    private static long ceilRoundLog(double base, double num) {
        return Math.round(Math.ceil(Math.log(num) / Math.log(base)));
    }
}