#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <queue>

#define int long long

using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    queue<pair<int, int>> b;
    b.push(a[n - 1]);
    a.pop_back();
    while (!b.empty()) {
        pair<int, int> v = a.back();
        a.pop_back();
        cout << min(b.front().second + 1, v.second + 1) << " " << max(b.front().second + 1, v.second + 1) << "\n";
        b.front().first--;
        v.first--;
        if (b.front().first == 0) {
            b.pop();
        }
        if (v.first != 0) {
            b.push(v);
        }
    }
    return 0;
}
