#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

int best = 1e9;
vector<vector<int>> ans;

void solve1(vector<pair<int, int>> &d) {
    vector<vector<int>> g(d.size());
    queue<pair<int, int>> q;
    vector<int> depth(d.size());
    q.push(d[0]);
    int start = 1;
    while(q.size()) {
        auto v = q.front();
        q.pop();
        for(int i = 0; i < v.second && start < d.size(); i++, start++) {
            q.emplace(d[start].first, d[start].second - 1);
            g[v.first].push_back(d[start].first);
            depth[start] = depth[i] + 1;
        }
    }
    if(depth.back() * 2 < best) {
        best = depth.back() * 2;
        ans = g;
    }
}

void solve2(vector<pair<int, int>> &d) {
    vector<vector<int>> g(d.size());
    queue<pair<int, int>> q;
    vector<int> depth(d.size());
    q.emplace(d[0].first, d[0].second - 1);
    q.emplace(d[1].first, d[1].second - 1);
    g[d[0].first].push_back(d[1].first);
    int start = 2;
    while(q.size()) {
        auto v = q.front();
        q.pop();
        for(int i = 0; i < v.second && start < d.size(); i++, start++) {
            q.emplace(d[start].first, d[start].second - 1);
            g[v.first].push_back(d[start].first);
            depth[start] = depth[i] + 1;
        }
    }
    if(depth.back() * 2 + 1 < best) {
        best = depth.back() * 2 + 1;
        ans = g;
    }
}

int main() {
    FAST_IO;
    int n; cin >> n;
    vector<pair<int, int>> d(n);
    for(int i = 0; i < n; i++){
        cin >> d[i].second;
        d[i].first = i;
    }
    sort(d.begin(), d.end(), [&](auto &x, auto &y) {
        return x.second > y.second;
    });
    solve1(d);
    solve2(d);
    for(int i = 0; i < n; i++) {
        for(auto &to : ans[i]) {
            cout << i + 1 << " " << to + 1 << "\n";
        }
    }
}