#include <bits/stdc++.h>

int chess[2000][2000];

void a(int *x, int *y)
{
    if ((chess[*x + 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)++;
    }
    else if ((chess[*x - 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)--;
    }
    else if (chess[*x][*y - 1] != 0)
    {
        (*y)--;
    }
    else if (chess[*x - 1][*y] != 0)
    {
        (*x)--;
    }
    else if (chess[*x + 1][*y] != 0)
    {
        (*x)++;
    }
    else if (chess[*x][*y + 1] != 0)
    {
        (*y)++;
    }
}

void b(int *x, int *y)
{
    if ((chess[*x + 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)++;
    }
    else if ((chess[*x - 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)--;
    }
    else if (chess[*x + 1][*y] != 0)
    {
        (*x)++;
    }
    else if (chess[*x][*y - 1] != 0)
    {
        (*y)--;
    }
    else if (chess[*x][*y + 1] != 0)
    {
        (*y)++;
    }
    else if (chess[*x - 1][*y] != 0)
    {
        (*x)--;
    }
}

void c(int *x, int *y)
{
    if ((chess[*x + 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)++;
    }
    else if ((chess[*x - 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)--;
    }
    else if (chess[*x][*y + 1] != 0)
    {
        (*y)++;
    }
    else if (chess[*x - 1][*y] != 0)
    {
        (*x)--;
    }
    else if (chess[*x][*y - 1] != 0)
    {
        (*y)--;
    }
    else if (chess[*x + 1][*y] != 0)
    {
        (*x)++;
    }
}

void d(int *x, int *y)
{
    if ((chess[*x + 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)++;
    }
    else if ((chess[*x - 1][*y] != 0) && (chess[*x + 1][*y + 1] == 2))
    {
        (*x)--;
    }
    else if (chess[*x - 1][*y] != 0)
    {
        (*x)--;
    }
    else if (chess[*x][*y - 1] != 0)
    {
        (*y)--;
    }
    else if (chess[*x + 1][*y] != 0)
    {
        (*x)++;
    }
    else if (chess[*x][*y + 1] != 0)
    {
        (*y)++;
    }
}

int main()
{
    int n, x0, y0;

    std::cin >> n;

    for (int i = 0; i < n; i++)
    {
        std::cin >> x0 >> y0;

        chess[2 * x0][2 * y0] = 1;
        chess[2 * x0 + 1][2 * y0] = 1;
        chess[2 * x0][2 * y0 + 1] = 1;
        chess[2 * x0 + 1][2 * y0 + 1] = 1;
    }

    x0 *= 2;
    y0 *= 2;

    while ((chess[x0 + 1][y0]) || (chess[x0][y0 + 1]) || (chess[x0][y0 - 1]) || (chess[x0 - 1][y0]))
    {
        std::cout << x0 << ' ' << y0 << std::endl;

        chess[x0][y0] = 2;

        if (x0 % 2 == 0)
        {
            if (y0 % 2 == 0)
            {
                a(&x0, &y0);
            }
            else
            {
                d(&x0, &y0);
            }
        }
        else
        {
            if (y0 % 2 == 0)
            {
                b(&x0, &y0);
            }
            else
            {
                c(&x0, &y0);
            }
        }
    }

    return 0;
}

