#include <iostream>
#include <string>

#include <iomanip>

using real = double;

int main(void)
{
  static const real pi = 3.14159265358979323846;
  real r, R, a;
  int n;
  std::cin >> r >> R >> n;
  a = R - r;

  std::cout << std::setprecision(12);
  std::cout.precision(12);

  if (n == 1)
  {
    std::cout << pi * r / 2;
    return 0;
  }
  else if (n == 2)
  {
    std::cout << pi * R + pi * r / 2;
    return 0;
  }
  else if (n == 3)
  {
    real a = pi * (2 * R - r / 2), b = pi * (4 * R / 3 + 5 * r / 9);
    std::cout << (a <= b ? a : b);
    return 0;
  }

  if (n & 1)
  {
    /* odd */
#if 0
    if (n > 2 * (R - r) / r)
    {
      /* don't go up */
      std::cout << pi * (2 * a / n * ((n + 1) / 2) + 2 * R / n * (n / 2) + n * r / 2);
      return 0;
    }
    else
    {
#endif /* 0 */
      /* go up */
      std::cout << pi * (n * r / 2 + (n / 2) * (4 * R - 2 * r) / n);
      return 0;
//    }
  }
  else
  {
#if 0
    /* even */
    if (n > 4 * R / r)
    {
      /* don't go up */
      std::cout << 2 * pi * (n * r / 4 + (n / 2) * (R + a) / n);
      return 0;
    }
    else
    {
#endif
      /* go up */
      std::cout << pi * (2 * r + (n / 2) * 2 * R / n + ((n - 1) / 2) * 2 * (R - r) / n);
      return 0;
//    }
  }
  // if (n <= 4)
  //   s = pi * (r * n + 4 * a);
  // else
  //   s = pi * n * (r / 2 + ((n + 1) / 2) * 2.0 / n * 2 * R +
  //                         (n / 2) * 2.0 / n * 2 * R);
  
  return 0;
}