#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
using namespace std;


int main() {
    int n;
    cin >> n;
    vi a(n);
    set<pair<int, int> > big;
    set<pair<int, int> > small;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        big.insert(make_pair(-a[i], -i));
        small.insert(make_pair(a[i], i));
    }
    vector<pair<int, int> > ans;
    for (int j = 0; j + 1 < n; ++j) {
        int x = small.begin()->first;
        int ind1 = small.begin()->second;
        int y = -big.begin()->first;
        int ind2 = -big.begin()->second;
        small.erase({x,ind1});
        small.erase({y,ind2});
        big.erase({-x,-ind1});
        big.erase({-y,-ind2});
        ans.push_back(make_pair(ind1 + 1, ind2 + 1));
        x--;
        y--;
        if (x != 0) {
            small.insert(make_pair(x, ind1));
            big.insert(make_pair(-x, -ind1));
        }
        if (y != 0) {
            small.insert(make_pair(y, ind2));
            big.insert(make_pair(-y, -ind2));
        }
    }
    for (auto p : ans) {
        cout << p.first << " " << p.second << endl;
    }
    return 0;
}