#include <bits/stdc++.h>

using namespace std;


bool field[2010][2010];

bool get(int x, int y) {
    if (x < 0 || y < 0) {
        return true;
    } else {
        return field[x][y];
    }
}

vector<pair<int, int>> path;
vector<pair<int, int>> res;
bool ans = false;

int n = 0;

void dfs(int x, int y) {
    if (ans || get(x, y)) {
        return;
    }
    field[x][y] = true;
    path.emplace_back(x, y);
    if (path.size() == n * 4 && (abs(path[0].first - path[path.size() - 1].first) == 1) ^
                                (abs(path[0].second - path[path.size() - 1].second) == 1)) {
        res = path;
        ans = true;
        return;
    }
    dfs(x + 1, y);
    if (ans) { return; }
    dfs(x - 1, y);
    if (ans) { return; }
    dfs(x, y + 1);
    if (ans) { return; }
    dfs(x, y - 1);
    if (ans) { return; }

    path.pop_back();
    field[x][y] = false;
}


int main() {
    for (int i = 0; i < 2010; ++i) {
        for (int j = 0; j < 2010; ++j) {
            field[i][j] = true;
        }
    }
    cin >> n;
    int sx, sy;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        sx = x;
        sy = y;
        field[2 * x][2 * y] = false;
        field[2 * x][2 * y + 1] = false;
        field[2 * x + 1][2 * y] = false;
        field[2 * x + 1][2 * y + 1] = false;
    }
    dfs(sx, sy);
    for (auto e : res) {
        cout << e.first << " " << e.second << endl;
    }
}
