
#include <bits/stdc++.h>
#define left izban_is_god

using namespace std;

typedef long long ll;

#ifdef ONPC
	mt19937 rnd(228);
#else
	mt19937 rnd(time(0));
#endif

int f[5][15][5][15];

const int M = 998244353;

inline int add(int a, int b)
{
	a += b;
	if (a < 0) a += M;
	if (a >= M) a -= M;
	return a;
}

inline int mul(int a, int b)
{
	return (a * (ll) b) % M;
}

const int inf = 1e9;

struct hsh
{
	int operator () (const vector <int> &a) const
	{
		int h = 0;
		for (int x : a) h = h * 239 + x;
		return h;
	}
};

int left[5], up[5];

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	int n = 5, m = 15, k = 0;
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			for (int x = 0; x < n; x++)
			{
				for (int y = 0; y < m; y++)
				{
					f[i][j][x][y] = -1;
				}
			}
		}
	}
	for (int i = 0; i < k; i++)
	{
		int r1, c1, r2, c2, w;
		cin >> r1 >> c1 >> r2 >> c2 >> w;
		r1--, c1--, r2--, c2--;
		f[r1][c1][r2][c2] = f[r2][c2][r1][c1] = w;
	}
	unordered_map <vector <int>, ll, hsh> dp;
	vector <int> arr(n, inf);
	arr[n - 1] = 0;
	dp[arr] = 1;
	ll ans = 0;
	vector <int> cur(n), d(n);
	unordered_map <vector <int>, ll, hsh> ndp;
	unordered_map <vector <int>, ll, hsh> go_cur;
	ndp.clear(), go_cur.clear();
	for (int j = m - 1; j >= 0; j--)
	{
		ndp.clear(), go_cur.clear();
		int can_up = (1 << (n - 1));
		if (j != 0) for (int i = 0; i < n; i++) left[i] = f[i][j][i][j - 1];
		for (int i = 0; i + 1 < n; i++) up[i] = f[i][j][i + 1][j];
		for (auto c : dp)
		{
			for (int mask_up = 0; mask_up < can_up; mask_up++)
			{
				cur = c.first;
				bool bad = false;
				for (int i = n - 2; i >= 0; i--)
				{
					if ((mask_up >> i) & 1)
					{
						if (up[i] == 1) bad = true;
						cur[i] = min(cur[i], cur[i + 1] + 0);
					}
					else
					{
						if (up[i] == 0) bad = true;
						cur[i] = min(cur[i], cur[i + 1] + 1);
					}
				}
				if (!bad) go_cur[cur] += c.second;
			}
		}
		int can_left = (1 << n);
		if (j == 0) can_left = 1;
		for (auto c : go_cur)
		{
			cur = c.first;
			for (int mask_left = 0; mask_left < can_left; mask_left++)
			{
				for (int i = 0; i < n; i++) d[i] = inf;
				bool bad = false;
				if (j != 0)
				for (int i = 0; i < n; i++)
				{
					if ((mask_left >> i) & 1)
					{
						if (left[i] == 1) bad = true;
						d[i] = min(d[i], cur[i] + 0);
					}
					else
					{
						if (left[i] == 0) bad = true;
						d[i] = min(d[i], cur[i] + 1);
					}
				}
				if (!bad)
				{
					ndp[d] += c.second;
					if (j == 0)
					{
						if (*min_element(cur.begin(), cur.end()) == *max_element(cur.begin(), cur.end()))
						{
							ans += c.second;
						}
					}
				}
			}
		}
		dp = ndp;
		for (auto &c : dp) c.second %= M;
	}
//	cout << clock() / (double) CLOCKS_PER_SEC << endl;
	cout << ans % M << '\n';
}
