import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        double n = s.nextDouble();
        double m = s.nextDouble();
        double h = s.nextDouble();
        double w = s.nextDouble();

        long count = 0;
        while (true) {
            if (rotate(n, m, h, w)) break;

            if (h < n && w < n) {
                n = n / 2.0D;
                ++count;
            }
            if (h < m && w < m) {
                m = m / 2.0D;
                ++count;
            }

            if (rotate(n, m, h, w)) break;

            if (h >= n) {
                if (h >= m && m > w) {
                    if (Math.min(n, m) == m) m = m / 2.0D;
                    else n = n / 2.0D;
                    ++count;
                }
            } else {
                if (w >= n) {
                    if (w >= m && m > h) {
                        if (Math.min(n, m) == m) m = m / 2.0D;
                        else n = n / 2.0D;
                        ++count;
                    }
                }
            }
        }
        System.out.println(count);
    }

    private static boolean rotate(double n, double m, double h, double w) {
        if (h >= n && w >= m) return true;
        if (h >= m && w >= n) return true;
        return false;
    }
}
