import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class TaskC {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int time = sc.nextInt();
        double[] t = new double[n];
        long[] p = new long[n];
        for (int i = 0; i < n; i++) {
            t[i] = sc.nextDouble();
            p[i] = sc.nextLong();
        }
        double[][] res = new double[n][2];
        for (int i = 0; i < n; i++) {
            res[i][0] = t[i] / p[i];
            res[i][1] = i;
        }
        Comparator<double[]> pc = new Comparator<double[]>() {
            @Override
            public int compare(double[] o1, double[] o2) {
                if (o1[0] > o2[0]) {
                    return 1;
                } else {
                    if (o1[0] == o2[0]) {
                        return 0;
                    } else {
                        return -1;
                    }
                }
            }
        };
        Arrays.sort(res, pc);
        int cur_t = 0;
        long points = 0;
        for (int i = n - 1; i >= 0; i--) {
            cur_t += t[(int) (res[i][1])];
            points += p[(int) (res[i][1])];
            if (cur_t > time) {
                points -= p[(int) (res[i][1])];
                break;
            }
        }
        System.out.println(points);
    }
}
