import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Locale;

public class Task {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        String[] enter = reader.readLine().split(" ");
        double n, m, h, w;
        n = Long.parseLong(enter[0]);
        m = Long.parseLong(enter[1]);
        h = Long.parseLong(enter[2]);
        w = Long.parseLong(enter[3]);
        long var1 = ceilRoundLog(2d, n / h) + ceilRoundLog(2d, m / w);
        long var2 = ceilRoundLog(2d, n / 2) + ceilRoundLog(2d, n / h);
        long res = Math.min(var1, var2);
        System.out.println(res < 0 ? 0 : res);
    }

    private static long ceilRoundLog(double base, double num) {
        return Math.round(Math.ceil(Math.log(num) / Math.log(base)));
    }
}