#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>

#define int long long

using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long double n, m, w, h;
    cin >> n >> m >> w >> h;
    int ans = 0;
    while (max(n, m) > max(w, h) || min(n, m) > min(w, h)) {
        if (n > m) {
            swap(n, m);
        }
        if (w > h) {
            swap(w, h);
        }
        if (m > h) {
            m /= 2;
        }
        else if (n > w) {
            n /= 2;
        }
        ans++;
    }
    cout << ans;
    return 0;
}
