#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

int pw[6], cn;
const int MX = 20 * 20 * 20 * 20 * 20;
const int MOD = 998244353;
int num[MX], mask[MX], n, m;
int w[5][25], h[5][15];

void go(int pos, int ms, int last) {
    if (pos == n) {
        num[ms] = cn;
        mask[cn++] = ms;
        return;
    }
    for (int i = 0; i <= last + 1; i++)
        go(pos + 1, ms * 20 + i, i);
}

int getb(int x, int pos) {
    return x / pw[pos] % 20;
}

void rel(int c1, int a1, int b1, int c2, int a2, int b2, vector<vector<vector<ll>>> &dp) {
    dp[a1][b1][c1] += dp[a2][b2][c2];
    if (dp[a1][b1][c1] >= MOD)
        dp[a1][b1][c1] -= MOD;
}

int main() {
    FAST_IO;
    pw[0] = 1;
    for (int i = 1; i < 6; i++)
        pw[i] = pw[i - 1] * 20;
    int k, ax, ay, bx, by, t;
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        cin >> ax >> ay >> bx >> by >> t;
        ax--; bx--; ay--; by--;
        if (ax > bx || ay > by) {
            swap(ax, bx);
            swap(ay, by);
        }
        if (ax == bx)
            h[ax][ay] = t * 2 - 1;
        else
            w[ax][ay] = t * 2 - 1;
    }
    go(0, 0, 13);
    vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(m, vector<ll>(cn)));
    for (int i = 0; i < (1 << (n - 1)); i++) {
        int fl = 0;
        for (int j = 0; j < n - 1; j++) {
            int cb = (i & (1 << j)) ? 1 : 0;
            if (w[j][m - 1] && w[j][m - 1] != cb * 2 - 1)
                fl = 1;
        }
        if (fl)
            continue;
        int s = 0, cm = 0;
        for (int j = n - 2; j >= 0; j--) {
            if (i & (1 << j))
                s++;
            cm += s * pw[j];
        }
        dp[0][m - 1][num[cm]]++;
    }
    for (int i = m - 2; i >= 0; i--) {
        for (int l = 0; l < cn; l++) {
            for (int t2 = 0; t2 < 2; t2++) {
                if (h[n - 1][i] && h[n - 1][i] != t2 * 2 - 1)
                    continue;
                int nd = getb(mask[l], n - 1) + t2;
                rel(num[mask[l] + pw[n - 1] * (nd - getb(mask[l], n - 1))], n - 1, i, l, 0, i + 1, dp);
            }
        }
        for (int j = n - 2; j >= 0; j--) {
            for (int l = 0; l < cn; l++)
                for (int t1 = 0; t1 < 2; t1++)
                    for (int t2 = 0; t2 < 2; t2++) {
                        if (h[j][i] && h[j][i] != t2 * 2 - 1 || w[j][i] && w[j][i] != t1 * 2 - 1)
                            continue;
                        int nd = min(getb(mask[l], j) + t2, getb(mask[l], j + 1) + t1);
                        rel(num[mask[l] + pw[j] * (nd - getb(mask[l], j))], j, i, l, j + 1, i, dp);
                    }
        }
    }
    ll ans = 0;
    for (int i = 0; i < 15; i++) {
        int vm = 0;
        for (int j = 0; j < n; j++)
            vm = vm * 20 + i;
        ans = (ans + dp[0][0][num[vm]]) % MOD;
    }
    cout << ans;
}
