#include <iostream>
#include <string>

using UINT64 = unsigned long long;

int maxpow2(UINT64 A)
{
  if (A == 0)
    return 0;

  UINT64 buf = A;

  int pow = 0;
  while (A > 0)
    A >>= 1, pow++;
  pow--;
  if (buf > (1ULL << pow))
    pow++;
  return pow;// - //(2 << pow > A - 1);//2;
}

int main(void)
{
  UINT64 n, m, h, w;
  std::cin >> n >> m >> h >> w;

  int
    s1 = maxpow2((n + w - 1) / w) + maxpow2((m + h - 1) / h),
    s2 = maxpow2((n + h - 1) / h) + maxpow2((m + w - 1) / w);

  if (s1 < s2)
    std::cout << s1;
  else
    std::cout << s2;
  return 0;
}