#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

#define pb push_back
using namespace std;

int main() {
    int n;
    cin >> n;
    vector<vector<bool>> a(3000, vector<bool>(3000));
    vector<vector<bool>> used(3000, vector<bool>(3000, 1));
    int x0 = 1e9;
    int y0 = 1e9;
    int x1 = -1e9;
    for (int i = 0; i < 3000; ++i) {
        for (int j = 0; j < 3000; ++j) used[i][j] = true;
    }
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[2 * x][2 * y] = 1;
        a[2 * x + 1][2 * y] = 1;
        a[2 * x][2 * y + 1] = 1;
        a[2 * x + 1][2 * y + 1] = 1;
        used[2 * x][2 * y] = 0;
        used[2 * x + 1][2 * y] = 0;
        used[2 * x][2 * y + 1] = 0;
        used[2 * x + 1][2 * y + 1] = 0;
        if (2 * x < x0) {
            x0 = 2 * x;
            y0 = 2 * y;
        }
        if (2 * x + 1 > x1) {
            x1 = 2 * x + 1;
        }
        if (2 * x == x0 && 2 * y < y0) {
            x0 = 2 * x;
            y0 = 2 * y;
        }
    }
    int x = x0+1;
    int y = y0;
    vector<pair<int, int>> ans;
    ans.pb({x0, y0});
    while (true) {
        used[x][y] = 1;
        ans.pb({x, y});
        if (x > 0 && a[x - 1][y] && !used[x - 1][y]) {
            x--;
        } else if (a[x][y + 1] && !used[x][y + 1]) {
            y++;
        } else if (a[x + 1][y] && !used[x + 1][y]) {
            x++;
        } else {
            y--;
        }
        if (x == x0 && y == y0) break;
    }
    for (int i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << endl;
    return 0;
}
